unit GroupboxJL;       //basado en el componente Bajado de http://www.delphigroups.info/2/d6/303041.html y adaptado por mi
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;
type
  TCorc = (CNone,CPar,CCor,CLlav,CFle);
  TGroupBoxJL = class(TGroupBox)
  private
    { private declarations }
    FBevelLowColor: TColor;
    FBevelHiColor : TColor;
    //---------------------Mios
    FCaptionColor : TColor;
    FCaptionCorc  : TCorc;
    FDoubleLine   : Boolean;
    FSeparation   : Integer;
    //-------------------------
    FBevelWidth   : Integer;
    procedure SetBvlLowColor(Value: TColor);
    procedure SetBvlHiColor(Value: TColor);
    //---------------------------Mios
    procedure SetCaptionColor(Value: TColor);
    procedure SetCaptionCorc(Value: TCorc);
    procedure SetDoubleLine(Value: Boolean);
    procedure SetSeparation(Value: Integer);
    //-----------------------------
    procedure SetBevelWidth(Value: Integer);
    procedure CMDialogChar(var Message: TCMDialogChar); message CM_DIALOGCHAR;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMCtl3DChanged(var Message: TMessage); message CM_CTL3DCHANGED;
    procedure WMSize(var Message: TMessage); message WM_SIZE;
  protected
    { protected declarations }
    procedure CreateParams(Var Params:TCreateparams); override;
    procedure Paint; override;
    procedure SetParent(AParent:TWinControl); override;
    procedure AlignControls(AControl: TControl; var Rect: TRect); override;
    procedure DrawFrame(Rect:TRect);
    procedure DrawFlatFrame(Rect:TRect);
    procedure InvalidateFrame;
  public
    { public declarations }
    Constructor Create(AOwner:TComponent); override;
  published
    { published declarations }
    property BevelShadowColor   :TColor  read FBevelLowColor  	write SetBvlLowColor;
    property BevelHighlightColor:TColor  read FBevelHiColor     write SetBvlHiColor;
    property BevelWidth         :Integer read FBevelWidth       write SetBevelWidth 	default 1;
    //---------------------Mios
    property CaptionColor				:TColor  read FCaptionColor			write SetCaptionColor;
    property CaptionCorc				:TCorc	 read FCaptionCorc			write SetCaptionCorc;
    property DoubleLine					:Boolean read FDoubleLine				write SetDoubleLine;
    property Separation					:Integer read FSeparation				write SetSeparation;
    //-------------------------
    property Align;
    property Caption;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnendDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;
procedure Register;
implementation
procedure Register;
begin
  RegisterComponents('Standard', [TGroupBoxJL]);
end;
constructor TGroupBoxJL.Create (AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csAcceptsControls, csCaptureMouse, csClickEvents,
  csSetCaption, csDoubleClicks, csReplicatable];
  FBevelLowColor 	:= clBtnShadow;
  FBevelHiColor  	:= clBtnHighlight;
  FBevelWidth 		:= 1;
  FCaptionColor		:=clNavy;
  FCaptionCorc		:= CNone;
  FDoubleLine			:=False;
  FSeparation			:=2;
end;
procedure TGroupBoxJL.CreateParams(Var Params:TCreateparams);
begin
  inherited CreateParams (Params);
  with Params.WindowClass do
    Style := Style and not (CS_HREDRAW or CS_VREDRAW);
end;
procedure TGroupBoxJL.Paint;
var
  H: Integer;
  R,R2: TRect;
  Text2:string;
begin
  // No call to inherited needed.
  // inherited Paint;
  with Canvas do
  begin
    Font := Self.Font;
    H := TextHeight('0');
    R := Rect(0, H div 2 - 1, Width, Height);
    if Ctl3D=true then R2:=Rect(0+FSeparation+1,H div 2 + FSeparation,Width-((FSeparation*2)),Height- ((FSeparation*2)))
                  else R2:=Rect(0+FSeparation+1,H div 2 + FSeparation,Width-((FSeparation*2)-1),Height- ((FSeparation*2)-1));
    if Ctl3D then
    begin
      DrawFrame(R);
      if FDoubleLine=true then DrawFlatFrame(R2);
    end else
    begin
      Brush.Color := FBevelLowColor;
      DrawFlatFrame(R);
      if FDoubleLine=true then DrawFlatFrame(R2);;
    end;
    if Text <> '' then
    begin
      R := Rect(8, 0, 0, H);
      Brush.Style := bsClear;
      Font.color:=FCaptionColor;
      case FCaptionCorc of
        CNone:begin
				        DrawText(Handle, PChar(Text), Length(Text), R, DT_LEFT or DT_SINGLELINE or DT_CALCRECT);
                text2:=Text;
        			end;
        CPar: begin
                Text2:='('+Text+')';
				        DrawText(Handle, PChar(Text2), Length(Text2), R, DT_LEFT or DT_SINGLELINE or DT_CALCRECT);
        			end;
        CCor: begin
                Text2:='['+Text+']';
				        DrawText(Handle, PChar(Text2), Length(Text2), R, DT_LEFT or DT_SINGLELINE or DT_CALCRECT);
        			end;
        CLlav:begin
                Text2:='{'+Text+'}';
				        DrawText(Handle, PChar(Text2), Length(Text2), R, DT_LEFT or DT_SINGLELINE or DT_CALCRECT);
        			end;
        CFle: begin
                Text2:='<'+Text+'>';
				        DrawText(Handle, PChar(Text2), Length(Text2), R, DT_LEFT or DT_SINGLELINE or DT_CALCRECT);
        			end;
      end;
      // **********************
      if not Enabled then
      begin
        OffsetRect(R, 1, 1);
        Canvas.Font.Color := clBtnHighlight;
        DrawText(Canvas.Handle, PChar(Text), Length(Text), R, DT_LEFT or DT_SINGLELINE);
        OffsetRect(R, -1, -1);
        Canvas.Font.Color := clBtnShadow;
        DrawText(Canvas.Handle, PChar(Text2), Length(Text2), R, DT_LEFT or DT_SINGLELINE);
      end  else DrawText(Canvas.Handle, PChar(Text2), Length(Text2), R, DT_LEFT or DT_SINGLELINE);
  // ****************************
      // DrawText(Handle, PChar(Text), Length(Text), R, );
    end;
  end;
end;
procedure TGroupBoxJL.AlignControls(AControl: TControl; var Rect: TRect);
begin
  Canvas.Font := Font;
  Inc(Rect.Top, Canvas.TextHeight('0'));
  InflateRect(Rect, -1, -1);
  if Ctl3d then InflateRect(Rect, -1, -1);
  inherited AlignControls(AControl, Rect);
end;
procedure TGroupBoxJL.SetParent(AParent:TWinControl);
begin
  inherited SetParent(AParent);
  if Parent <> nil then
    SetWindowLong(Parent.Handle, GWL_STYLE,
       GetWindowLong(Parent.Handle, GWL_STYLE)
          and not WS_ClipChildren);
end;
procedure TGroupBoxJL.SetBvlLowColor(Value: TColor);
begin
  if FBevelLowColor <> Value then
    FBevelLowColor := Value;
  InvalidateFrame;
  Realign;
  Repaint;
end;
procedure TGroupBoxJL.SetBvlHiColor(Value: TColor);
begin
  if FBevelHiColor <> Value then
    FBevelHiColor := Value;
  InvalidateFrame;
  Realign;
  Repaint;
end;
//----------------------------------Mios
procedure TGroupBoxJL.SetCaptionColor(Value: TColor);
begin
  if FCaptionColor<>Value then FCaptionColor:=Value;
  Repaint;
end;

procedure TGroupBoxJL.SetCaptionCorc(Value: TCorc);
begin
  if FCaptionCorc<>Value then FCaptionCorc:=Value;
  Repaint;
end;

procedure TGroupBoxJL.SetDoubleLine(Value: Boolean);
begin
  if FDoubleLine<>value then FDoubleLine:=Value;
  Repaint;
end;

procedure TGroupBoxJL.SetSeparation(Value: Integer);
begin
  if Value>5 then
  begin
    ShowMessage('El valor mximo permitido es 5');
    Value:=5;
  end;
  if FSeparation<>value then FSeparation:=Value;
  Repaint;
end;
//-------------------------------------------
procedure TGroupBoxJL.DrawFrame(Rect: TRect);
var
  CaptionLength: Integer;
  Text2:string;
begin
  case FCaptionCorc of
        CNone	:Text2:=TEXT;
        CPar	:Text2:='('+Text+')';
        CCor  :Text2:='['+Text+']';
        CLlav :Text2:='{'+Text+'}';
        CFle	:Text2:='<'+Text+'>';
      end;
  with Canvas do
  begin
    Inc(Rect.Left, FBevelWidth);             //   0,5           199,5
    Inc(Rect.Top, FBevelWidth);              //
    Dec(Rect.Right, FBevelWidth);            //
    Dec(Rect.Bottom, FBevelWidth);           //   0,198         198,198
    CaptionLength := TextWidth(Text2);        //
    Pen.Color := FBevelHiColor;              //
    Pen.Width := FBevelWidth;                //   1,7          200,7
    MoveTo(Rect.Left, Rect.Top);             //
    LineTo(6,Rect.Top);                      //
    MoveTo(8+CaptionLength+2, Rect.Top);     //   1,200        200,200
    LineTo(Rect.Right,Rect.Top);             //
    LineTo(Rect.Right,Rect.Bottom);
    LineTo(Rect.Left,Rect.Bottom);
    LineTo(Rect.Left, Rect.Top);
    Pen.Color := FBevelLowColor;
    Pen.Width := FBevelWidth;
    OffsetRect(Rect, -FBevelWidth, -FBevelWidth);
    MoveTo(Rect.Left, Rect.Top);
    LineTo(6,Rect.Top);
    MoveTo(8+CaptionLength+2, Rect.Top);
    LineTo(Rect.Right,Rect.Top);
    LineTo(Rect.Right,Rect.Bottom);
    LineTo(Rect.Left,Rect.Bottom);
    LineTo(Rect.Left, Rect.Top);
  end;
end;
procedure TGroupBoxJL.DrawFlatFrame(Rect: TRect);
var
  CaptionLength: Integer;
  Text2:string;
begin
  case FCaptionCorc of
        CNone	:Text2:=TEXT;
        CPar	:Text2:='('+Text+')';
        CCor  :Text2:='['+Text+']';
        CLlav :Text2:='{'+Text+'}';
        CFle	:Text2:='<'+Text+'>';
      end;
  with Canvas do
  begin
    Dec(Rect.Right);
    Dec(Rect.Bottom);
    CaptionLength := TextWidth(Text2);
    Pen.Color := FBevelLowColor;
    Pen.Width := FBevelWidth;
    MoveTo(Rect.Left, Rect.Top);
    LineTo(6,Rect.Top);
    MoveTo(8+CaptionLength+2, Rect.Top);
    LineTo(Rect.Right,Rect.Top);
    LineTo(Rect.Right,Rect.Bottom);
    LineTo(Rect.Left,Rect.Bottom);
    LineTo(Rect.Left, Rect.Top);
  end;
end;
procedure TGroupBoxJL.CMDialogChar(var Message: TCMDialogChar);
begin
  with Message do
    if IsAccel(CharCode, Caption) and CanFocus then
    begin
      SelectFirst;
      Result := 1;
    end else
      inherited;
end;
procedure TGroupBoxJL.CMTextChanged(var Message: TMessage);
begin
  inherited;
  InvalidateFrame;
  Realign;
end;
procedure TGroupBoxJL.CMCtl3DChanged(var Message: TMessage);
begin
  inherited;
  InvalidateFrame;
  Realign;
end;
procedure TGroupBoxJL.WMSize(var Message: TMessage);
begin
  if (csDesigning in ComponentState) then
    InvalidateFrame;
  inherited;
end;
procedure TGroupBoxJL.InvalidateFrame;
var
  R: TRect;
begin
  R := BoundsRect;
  InflateRect(R, 1, 1);
  If (Parent <> Nil) and Parent.HandleAllocated then
    InvalidateRect(Parent.Handle, @R, True)
  Else
    inherited Invalidate;
end;
procedure TGroupBoxJL.SetBevelWidth(Value:Integer);
begin
  if Value <> FBevelWidth then
    FBevelWidth := Value;
  Repaint;
end;
end.
