{ ****************************************************************** }
{                                                                    }
{   VCL component TDbComboBoxExt                                     }
{                                                                    }
{   Combobox Extendido                                               }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from source file c:\copiados del disco duro portatil\descolocados\delphi\creador de componentes\dbcbext.cd }
{   on 6 Dec 2011 at 13:02                                           }
{                                                                    }
{   Copyright  2001 by J.L.G.T.                                     }
{                                                                    }
{ ****************************************************************** }

unit cbext;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Dbctrls, Windows, StdCtrls;

type
  TComboBoxExt = class(TComboBox)
    private
        FColorA : TColor;
        FColorB : TColor;
        FZebrado : Boolean;
        FChecks: Boolean;
        FTextSelected:string;
        Selected: array of Boolean;  //bajado de http://www.swissdelphicenter.ch/torry/showcode.php?id=2155
        procedure AutoInitialize;
        procedure AutoDestroy;
        procedure SetColorA(Value : TColor);
        procedure SetColorB(Value : TColor);
        procedure SetZebrado(Value : Boolean);
        procedure SetChecks(Value : Boolean);
    protected
        procedure Change; override;
        procedure Click; override;
        procedure KeyPress(var Key : Char); override;
        procedure Loaded; override;
        procedure DrawItem(Index: Integer;  Rect: TRect; State: TOwnerDrawState); override;
        procedure Select; override;
    public
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;

    published
        property OnChange;
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnEnter;
        property OnExit;
        property OnKeyDown;
        property OnKeyPress;
        property OnKeyUp;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        { Color inicial }
        property ColorA : TColor read FColorA write SetColorA default clCream;
        { Color Final }
        property ColorB : TColor read FColorB write SetColorB default clInfoBk;
        { Permite usar el Zebarado En El Componente }
        property Zebrado : Boolean   read FZebrado write SetZebrado   default False;
        property Checks: Boolean   read FChecks  write SetChecks  default False;
        property TextSelected : String read FTextSelected write FTextSelected;
  end;

procedure Register;

implementation

{$R COMBOBOXEXT.DCR}

procedure Register;
begin
     RegisterComponents('JLGTVISUAL', [TComboBoxExt]);
end;

procedure TComboBoxExt.AutoInitialize;
begin
     FColorA := clCream;
     FColorB := clInfoBk;
     FZebrado := False;
     FChecks:=False;
end;

procedure TComboBoxExt.AutoDestroy;
begin
     { No objects from AutoInitialize to free }
end; { of AutoDestroy }

procedure TComboBoxExt.SetColorA(Value : TColor);
begin
      if (FColorA<>Value) then FColorA:=Value;
end;

procedure TComboBoxExt.SetColorB(Value : TColor);
begin
      if (FColorB<>Value) then FColorB:=Value;
end;

procedure TComboBoxExt.SetZebrado(Value : Boolean);
begin
   if (FZebrado<>Value) then
   begin
     FZebrado:=Value;
     TDBComboBox(Self).Style:=csOwnerDrawFixed;
   end;
end;

procedure TComboBoxExt.SetChecks(Value: Boolean);
begin
   if (FChecks<>Value) then
   begin
     FChecks:=Value;
     TDBComboBox(Self).Style:=csOwnerDrawFixed;
   end;
end;

procedure TComboBoxExt.Change;
begin
     inherited Change;
end;

procedure TComboBoxExt.Click;
begin
     inherited Click;
end;

procedure TComboBoxExt.KeyPress(var Key : Char);
begin
     inherited KeyPress(Key);
end;

constructor TComboBoxExt.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;
end;

destructor TComboBoxExt.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

procedure TComboBoxExt.Loaded;
begin
     inherited Loaded;
end;

procedure TComboBoxExt.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
   if FZebrado=true then  //Idea bajada de http://www.swissdelphicenter.ch/torry/showcode.php?id=1885
   begin
     if Odd(Index) then TComboBox(Self).Canvas.Brush.color:=FColorA
                   else TComboBox(Self).Canvas.Brush.color:=FColorB;
     TComboBox(Self).Canvas.FillRect(Rect);
     TComboBox(Self).Canvas.Font.Color:=Font.Color;
     TComboBox(Self).Canvas.TextOut(Rect.Left,Rect.Top,Items[Index]);
   end;
   if FChecks=true then            //Bajado de http://www.swissdelphicenter.ch/torry/showcode.php?id=2155
   begin
      SetLength(Selected, TComboBox(Self).Items.Count);
      with TComboBox(Self).Canvas do
      begin
        FillRect(rect);
        Rect.Left := Rect.Left + 1;
        Rect.Right := Rect.Left + 13;
        Rect.Bottom := Rect.Bottom;
        Rect.Top := Rect.Top;

        if not (odSelected in State) and (Selected[Index]) then DrawFrameControl(Handle, Rect, DFC_BUTTON,DFCS_BUTTONCHECK or DFCS_CHECKED or DFCS_FLAT)
        else if (odFocused in State) and (Selected[Index]) then DrawFrameControl(Handle, Rect, DFC_BUTTON,DFCS_BUTTONCHECK or DFCS_CHECKED or DFCS_FLAT)
        else if (Selected[Index]) then DrawFrameControl(Handle, Rect, DFC_BUTTON,DFCS_BUTTONCHECK or DFCS_CHECKED or DFCS_FLAT)
        else if not (Selected[Index]) then DrawFrameControl(Handle, Rect, DFC_BUTTON, DFCS_BUTTONCHECK or DFCS_FLAT);
        TextOut(Rect.Left + 15, Rect.Top, TComboBox(Self).Items[Index]);
      end;
   end;
end;

procedure TComboBoxExt.Select;      //bajado de http://www.swissdelphicenter.ch/torry/showcode.php?id=2155
var  i: Integer;
     Sel: string;
begin
  if FChecks=true then
  begin
    Sel := EmptyStr;
    Selected[TComboBox(Self).ItemIndex] := not Selected[TComboBox(Self).ItemIndex];
    for i := 0 to TComboBox(Self).Items.Count - 1 do
      if Selected[i] then  Sel := Sel + TComboBox(Self).Items[i] + ' ';
    FTextSelected:=Sel;
  end;
  inherited Select;
end;
end.
