{ ****************************************************************** }
{                                                                    }
{   VCL component TDBIBMemo                                          }
{                                                                    }
{   Memo para firebird                                               }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from untitled component definition                     }
{   on 24 March 2012 at 7:27                                         }
{                                                                    }
{   Copyright  2012 by J.L.G.T.                                     }
{                                                                    }
{ ****************************************************************** }

unit MyDbIbMemo;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Stdctrls, DbTables, DB, DBCtrls, Dialogs;

type
  TDBIBMemo = class(TMemo)
    private
      { Private fields of TDBIBMemo }
        FDataLink : TFieldDataLink;

      { Private methods of TDBIBMemo }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;
        function GetDataField : String;
        procedure SetDataField(Value : String);
        function GetDataSource : TDataSource;
        procedure SetDataSource(Value : TDataSource);
        procedure ActiveChange(Sender : TObject);
        procedure DataChange(Sender : TObject);
        procedure EditingChange(Sender : TObject);
        procedure UpdateData(Sender : TObject);

    protected
      { Protected fields of TDBIBMemo }
      { Guarda el Contenido }
        Texto : String;
      { Protected methods of TDBIBMemo }
        procedure Change; override;
        procedure Click; override;
        procedure DoEnter; override;
        procedure DoExit; override;
        procedure KeyPress(var Key : Char); override;
        procedure Loaded; override;

    public
      { Public fields and properties of TDBIBMemo }

      { Public methods of TDBIBMemo }
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;

    published
      { Published properties of TDBIBMemo }
        property OnChange;
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnEnter;
        property OnExit;
        property OnKeyDown;
        property OnKeyPress;
        property OnKeyUp;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        property DataField : String read GetDataField write SetDataField;
        property DataSource : TDataSource
             read GetDataSource write SetDataSource;

  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TDBIBMemo with InterBase as its
       default page on the Delphi component palette }
     RegisterComponents('InterBase', [TDBIBMemo]);
end;

{ Method to set variable and property values and create objects }
procedure TDBIBMemo.AutoInitialize;
begin
     FDataLink := TFieldDataLink.Create;
     with FDataLink do
     begin
          { Assign handlers }
          OnDataChange := DataChange;
          OnUpdateData := UpdateData;
          OnEditingChange := EditingChange;
          OnActiveChange := ActiveChange;
     end;
     Texto := '';
end; { of AutoInitialize }

{ Method to free any objects created by AutoInitialize }
procedure TDBIBMemo.AutoDestroy;
begin
     FDataLink.Free;
end; { of AutoDestroy }

function TDBIBMemo.GetDataField : String;
begin
     { Return the FDataLink.FieldName property }
     Result := FDataLink.FieldName;
end;

procedure TDBIBMemo.SetDataField(Value : String);
begin
     { Set the FDataLink.FieldName property }
     FDataLink.FieldName := Value;
end;

function TDBIBMemo.GetDataSource : TDataSource;
begin
     { Return the FDataLink.DataSource property }
     Result := FDataLink.DataSource;
end;

procedure TDBIBMemo.SetDataSource(Value : TDataSource);
begin
     { Set the FDataLink.DataSource property }
     FDataLink.DataSource := Value;
end;

{ Override OnChange handler from TCustomMemo }
procedure TDBIBMemo.Change;
begin
     inherited Change;
     if fDataLink.field <> nil then
     begin
        if  DataSource.DataSet.State in [dsInsert,dsEdit] then
        begin
		        FDataLink.Field.Value:=Self.Lines.Text;
            FDataLink.Modified;
        end;
     end;
end;

{ Override OnClick handler from TCustomMemo }
procedure TDBIBMemo.Click;
begin
     { Call method of parent class }
     inherited Click;
end;

{ Override OnEnter handler from TCustomMemo }
procedure TDBIBMemo.DoEnter;
begin
     inherited DoEnter;
     if fDataLink.field <> nil then
     begin
        Texto:=Self.Lines.Text;
        if not ( DataSource.DataSet.State in [dsInsert,dsEdit]) then FDataLink.Edit;
     end;
end;

{ Override OnExit handler from TCustomMemo }
procedure TDBIBMemo.DoExit;
begin
     inherited DoExit;
     if fDataLink.field <> nil then
     begin
        if  DataSource.DataSet.State in [dsInsert,dsEdit] then
        begin
           if Self.Lines.Text<>Texto then FDataLink.Field.Value:=Self.Lines.Text;
           FDataLink.Modified;
        end;
     end;
end;

{ Override OnKeyPress handler from TCustomMemo }
procedure TDBIBMemo.KeyPress(var Key : Char);
begin      { Call method of parent class }
     if FDataLink.Edit then
     begin
	     inherited KeyPress(Key);
       FDataLink.Modified;
       FDataLink.Field.Value:=Self.Lines.Text;
     end;
end;



procedure TDBIBMemo.ActiveChange(Sender : TObject);
{ Delphi 1.0/2.0 field types:
     ftUnknown, ftString, ftSmallint, ftInteger, ftWord,
     ftBoolean, ftFloat, ftCurrency, ftBCD, ftDate, ftTime,
     ftDateTime, ftBytes, ftVarBytes, ftBlob, ftMemo, ftGraphic
  Additional Delphi 2.0 field types:
     ftAutoInc, ftFmtMemo, ftParadoxOle, ftDBaseOle,
     ftTypedBinary }
const
     IntFieldTypes = [ftSmallInt, ftInteger, ftWord];
begin
     { Respond to OnActiveChange events of FDataLink }
     { When the dataset becomes active, validate the field type. }
     if DataField = '' then
        { No field selected }
        Exit;
//     if FDataLink <> nil then
//        if FDataLink.Dataset <> nil then
//           if FDataLink.Dataset.Active then
//              if FDataLink.Dataset.FieldByName(DataField).DataType
//                 <> ftString then
//                 raise EDatabaseError.Create('Wrong field type');

            { if not (FDataLink.Dataset.FieldByName(DataField).DataType
                 in IntFieldTypes) then
                 raise EDatabaseError.Create('Wrong field type'); }

end;

constructor TDBIBMemo.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;
     
     { Code to perform other tasks when the component is created }
     
end;

procedure TDBIBMemo.DataChange(Sender : TObject);
begin
   if DataSource.DataSet.IsEmpty<>true then
   begin
    if fDataLink.field <> nil then Self.Lines.Text:=FDataLink.Field.Value;
   end;
end;

destructor TDBIBMemo.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

procedure TDBIBMemo.EditingChange(Sender : TObject);
begin
     { Respond to OnEditingChange events of FDataLink }
     { The data source has gone from editing to non-editing,
       or the reverse; update the component's properties
       based on the value of FDataLink.Editing. }

     { ReadOnly := not FDataLink.Editing; }
     { . . . if the component has a ReadOnly property, or . . . }
     { Enabled := not FDataLink.Editing; }
end;

procedure TDBIBMemo.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;

procedure TDBIBMemo.UpdateData(Sender : TObject);
begin
     { Respond to OnUpdateData events of FDataLink }
     { The component has altered the data, so update FDataLink.Field.Text
       here based on properties of the component.  The component's
       methods indicate when a change has occurred by calling
       FDataLink.Modified. }
    if fDataLink.field <> nil then FDataLink.Field.Value:=Self.Lines.Text;

     
end;


end.
